diff --git a/lib/block/bdev.py b/lib/block/bdev.py
index 649d92e..773a6d4 100644
--- a/lib/block/bdev.py
+++ b/lib/block/bdev.py
@@ -22,11 +22,8 @@
 """Block device abstraction"""
 
 import re
-import time
 import errno
-import shlex
 import stat
-import pyparsing as pyp
 import os
 import logging
 import math
@@ -36,13 +33,10 @@ from ganeti import errors
 from ganeti import constants
 from ganeti import objects
 from ganeti import compat
-from ganeti import netutils
 from ganeti import pathutils
 from ganeti import serializer
-
-
-# Size of reads in _CanReadDevice
-_DEVICE_READ_SIZE = 128 * 1024
+from ganeti.block import drbd
+from ganeti.block import base
 
 
 class RbdShowmappedJsonError(Exception):
@@ -52,38 +46,6 @@ class RbdShowmappedJsonError(Exception):
   pass
 
 
-def _IgnoreError(fn, *args, **kwargs):
-  """Executes the given function, ignoring BlockDeviceErrors.
-
-  This is used in order to simplify the execution of cleanup or
-  rollback functions.
-
-  @rtype: boolean
-  @return: True when fn didn't raise an exception, False otherwise
-
-  """
-  try:
-    fn(*args, **kwargs)
-    return True
-  except errors.BlockDeviceError, err:
-    logging.warning("Caught BlockDeviceError but ignoring: %s", str(err))
-    return False
-
-
-def _ThrowError(msg, *args):
-  """Log an error to the node daemon and the raise an exception.
-
-  @type msg: string
-  @param msg: the text of the exception
-  @raise errors.BlockDeviceError
-
-  """
-  if args:
-    msg = msg % args
-  logging.error(msg)
-  raise errors.BlockDeviceError(msg)
-
-
 def _CheckResult(result):
   """Throws an error if the given result is a failed one.
 
@@ -91,22 +53,8 @@ def _CheckResult(result):
 
   """
   if result.failed:
-    _ThrowError("Command: %s error: %s - %s", result.cmd, result.fail_reason,
-                result.output)
-
-
-def _CanReadDevice(path):
-  """Check if we can read from the given device.
-
-  This tries to read the first 128k of the device.
-
-  """
-  try:
-    utils.ReadFile(path, size=_DEVICE_READ_SIZE)
-    return True
-  except EnvironmentError:
-    logging.warning("Can't read from device %s", path, exc_info=True)
-    return False
+    base.ThrowError("Command: %s error: %s - %s",
+                    result.cmd, result.fail_reason, result.output)
 
 
 def _GetForbiddenFileStoragePaths():
@@ -219,295 +167,7 @@ def CheckFileStoragePath(path, _filename=pathutils.FILE_STORAGE_PATHS_FILE):
   _CheckFileStoragePath(path, allowed)
 
 
-class BlockDev(object):
-  """Block device abstract class.
-
-  A block device can be in the following states:
-    - not existing on the system, and by `Create()` it goes into:
-    - existing but not setup/not active, and by `Assemble()` goes into:
-    - active read-write and by `Open()` it goes into
-    - online (=used, or ready for use)
-
-  A device can also be online but read-only, however we are not using
-  the readonly state (LV has it, if needed in the future) and we are
-  usually looking at this like at a stack, so it's easier to
-  conceptualise the transition from not-existing to online and back
-  like a linear one.
-
-  The many different states of the device are due to the fact that we
-  need to cover many device types:
-    - logical volumes are created, lvchange -a y $lv, and used
-    - drbd devices are attached to a local disk/remote peer and made primary
-
-  A block device is identified by three items:
-    - the /dev path of the device (dynamic)
-    - a unique ID of the device (static)
-    - it's major/minor pair (dynamic)
-
-  Not all devices implement both the first two as distinct items. LVM
-  logical volumes have their unique ID (the pair volume group, logical
-  volume name) in a 1-to-1 relation to the dev path. For DRBD devices,
-  the /dev path is again dynamic and the unique id is the pair (host1,
-  dev1), (host2, dev2).
-
-  You can get to a device in two ways:
-    - creating the (real) device, which returns you
-      an attached instance (lvcreate)
-    - attaching of a python instance to an existing (real) device
-
-  The second point, the attachment to a device, is different
-  depending on whether the device is assembled or not. At init() time,
-  we search for a device with the same unique_id as us. If found,
-  good. It also means that the device is already assembled. If not,
-  after assembly we'll have our correct major/minor.
-
-  """
-  def __init__(self, unique_id, children, size, params):
-    self._children = children
-    self.dev_path = None
-    self.unique_id = unique_id
-    self.major = None
-    self.minor = None
-    self.attached = False
-    self.size = size
-    self.params = params
-
-  def Assemble(self):
-    """Assemble the device from its components.
-
-    Implementations of this method by child classes must ensure that:
-      - after the device has been assembled, it knows its major/minor
-        numbers; this allows other devices (usually parents) to probe
-        correctly for their children
-      - calling this method on an existing, in-use device is safe
-      - if the device is already configured (and in an OK state),
-        this method is idempotent
-
-    """
-    pass
-
-  def Attach(self):
-    """Find a device which matches our config and attach to it.
-
-    """
-    raise NotImplementedError
-
-  def Close(self):
-    """Notifies that the device will no longer be used for I/O.
-
-    """
-    raise NotImplementedError
-
-  @classmethod
-  def Create(cls, unique_id, children, size, params, excl_stor):
-    """Create the device.
-
-    If the device cannot be created, it will return None
-    instead. Error messages go to the logging system.
-
-    Note that for some devices, the unique_id is used, and for other,
-    the children. The idea is that these two, taken together, are
-    enough for both creation and assembly (later).
-
-    """
-    raise NotImplementedError
-
-  def Remove(self):
-    """Remove this device.
-
-    This makes sense only for some of the device types: LV and file
-    storage. Also note that if the device can't attach, the removal
-    can't be completed.
-
-    """
-    raise NotImplementedError
-
-  def Rename(self, new_id):
-    """Rename this device.
-
-    This may or may not make sense for a given device type.
-
-    """
-    raise NotImplementedError
-
-  def Open(self, force=False):
-    """Make the device ready for use.
-
-    This makes the device ready for I/O. For now, just the DRBD
-    devices need this.
-
-    The force parameter signifies that if the device has any kind of
-    --force thing, it should be used, we know what we are doing.
-
-    """
-    raise NotImplementedError
-
-  def Shutdown(self):
-    """Shut down the device, freeing its children.
-
-    This undoes the `Assemble()` work, except for the child
-    assembling; as such, the children on the device are still
-    assembled after this call.
-
-    """
-    raise NotImplementedError
-
-  def SetSyncParams(self, params):
-    """Adjust the synchronization parameters of the mirror.
-
-    In case this is not a mirroring device, this is no-op.
-
-    @param params: dictionary of LD level disk parameters related to the
-    synchronization.
-    @rtype: list
-    @return: a list of error messages, emitted both by the current node and by
-    children. An empty list means no errors.
-
-    """
-    result = []
-    if self._children:
-      for child in self._children:
-        result.extend(child.SetSyncParams(params))
-    return result
-
-  def PauseResumeSync(self, pause):
-    """Pause/Resume the sync of the mirror.
-
-    In case this is not a mirroring device, this is no-op.
-
-    @param pause: Whether to pause or resume
-
-    """
-    result = True
-    if self._children:
-      for child in self._children:
-        result = result and child.PauseResumeSync(pause)
-    return result
-
-  def GetSyncStatus(self):
-    """Returns the sync status of the device.
-
-    If this device is a mirroring device, this function returns the
-    status of the mirror.
-
-    If sync_percent is None, it means the device is not syncing.
-
-    If estimated_time is None, it means we can't estimate
-    the time needed, otherwise it's the time left in seconds.
-
-    If is_degraded is True, it means the device is missing
-    redundancy. This is usually a sign that something went wrong in
-    the device setup, if sync_percent is None.
-
-    The ldisk parameter represents the degradation of the local
-    data. This is only valid for some devices, the rest will always
-    return False (not degraded).
-
-    @rtype: objects.BlockDevStatus
-
-    """
-    return objects.BlockDevStatus(dev_path=self.dev_path,
-                                  major=self.major,
-                                  minor=self.minor,
-                                  sync_percent=None,
-                                  estimated_time=None,
-                                  is_degraded=False,
-                                  ldisk_status=constants.LDS_OKAY)
-
-  def CombinedSyncStatus(self):
-    """Calculate the mirror status recursively for our children.
-
-    The return value is the same as for `GetSyncStatus()` except the
-    minimum percent and maximum time are calculated across our
-    children.
-
-    @rtype: objects.BlockDevStatus
-
-    """
-    status = self.GetSyncStatus()
-
-    min_percent = status.sync_percent
-    max_time = status.estimated_time
-    is_degraded = status.is_degraded
-    ldisk_status = status.ldisk_status
-
-    if self._children:
-      for child in self._children:
-        child_status = child.GetSyncStatus()
-
-        if min_percent is None:
-          min_percent = child_status.sync_percent
-        elif child_status.sync_percent is not None:
-          min_percent = min(min_percent, child_status.sync_percent)
-
-        if max_time is None:
-          max_time = child_status.estimated_time
-        elif child_status.estimated_time is not None:
-          max_time = max(max_time, child_status.estimated_time)
-
-        is_degraded = is_degraded or child_status.is_degraded
-
-        if ldisk_status is None:
-          ldisk_status = child_status.ldisk_status
-        elif child_status.ldisk_status is not None:
-          ldisk_status = max(ldisk_status, child_status.ldisk_status)
-
-    return objects.BlockDevStatus(dev_path=self.dev_path,
-                                  major=self.major,
-                                  minor=self.minor,
-                                  sync_percent=min_percent,
-                                  estimated_time=max_time,
-                                  is_degraded=is_degraded,
-                                  ldisk_status=ldisk_status)
-
-  def SetInfo(self, text):
-    """Update metadata with info text.
-
-    Only supported for some device types.
-
-    """
-    for child in self._children:
-      child.SetInfo(text)
-
-  def Grow(self, amount, dryrun, backingstore):
-    """Grow the block device.
-
-    @type amount: integer
-    @param amount: the amount (in mebibytes) to grow with
-    @type dryrun: boolean
-    @param dryrun: whether to execute the operation in simulation mode
-        only, without actually increasing the size
-    @param backingstore: whether to execute the operation on backing storage
-        only, or on "logical" storage only; e.g. DRBD is logical storage,
-        whereas LVM, file, RBD are backing storage
-
-    """
-    raise NotImplementedError
-
-  def GetActualSize(self):
-    """Return the actual disk size.
-
-    @note: the device needs to be active when this is called
-
-    """
-    assert self.attached, "BlockDevice not attached in GetActualSize()"
-    result = utils.RunCmd(["blockdev", "--getsize64", self.dev_path])
-    if result.failed:
-      _ThrowError("blockdev failed (%s): %s",
-                  result.fail_reason, result.output)
-    try:
-      sz = int(result.output.strip())
-    except (ValueError, TypeError), err:
-      _ThrowError("Failed to parse blockdev output: %s", str(err))
-    return sz
-
-  def __repr__(self):
-    return ("<%s: unique_id: %s, children: %s, %s:%s, %s>" %
-            (self.__class__, self.unique_id, self._children,
-             self.major, self.minor, self.dev_path))
-
-
-class LogicalVolume(BlockDev):
+class LogicalVolume(base.BlockDev):
   """Logical Volume block device.
 
   """
@@ -586,14 +246,14 @@ class LogicalVolume(BlockDev):
         msg = "No (empty) PVs found"
       else:
         msg = "Can't compute PV info for vg %s" % vg_name
-      _ThrowError(msg)
+      base.ThrowError(msg)
     pvs_info.sort(key=(lambda pv: pv.free), reverse=True)
 
     pvlist = [pv.name for pv in pvs_info]
     if compat.any(":" in v for v in pvlist):
-      _ThrowError("Some of your PVs have the invalid character ':' in their"
-                  " name, this is not supported - please filter them out"
-                  " in lvm.conf using either 'filter' or 'preferred_names'")
+      base.ThrowError("Some of your PVs have the invalid character ':' in their"
+                      " name, this is not supported - please filter them out"
+                      " in lvm.conf using either 'filter' or 'preferred_names'")
 
     current_pvs = len(pvlist)
     desired_stripes = params[constants.LDP_STRIPES]
@@ -608,8 +268,8 @@ class LogicalVolume(BlockDev):
       pvlist = cls._GetEmptyPvNames(pvs_info, req_pvs)
       current_pvs = len(pvlist)
       if current_pvs < req_pvs:
-        _ThrowError("Not enough empty PVs to create a disk of %d MB:"
-                    " %d available, %d needed", size, current_pvs, req_pvs)
+        base.ThrowError("Not enough empty PVs to create a disk of %d MB:"
+                        " %d available, %d needed", size, current_pvs, req_pvs)
       assert current_pvs == len(pvlist)
       if stripes > current_pvs:
         # No warning issued for this, as it's no surprise
@@ -623,8 +283,8 @@ class LogicalVolume(BlockDev):
       # The size constraint should have been checked from the master before
       # calling the create function.
       if free_size < size:
-        _ThrowError("Not enough free space: required %s,"
-                    " available %s", size, free_size)
+        base.ThrowError("Not enough free space: required %s,"
+                        " available %s", size, free_size)
 
     # If the free space is not well distributed, we won't be able to
     # create an optimally-striped volume; in that case, we want to try
@@ -636,8 +296,8 @@ class LogicalVolume(BlockDev):
       if not result.failed:
         break
     if result.failed:
-      _ThrowError("LV create failed (%s): %s",
-                  result.fail_reason, result.output)
+      base.ThrowError("LV create failed (%s): %s",
+                      result.fail_reason, result.output)
     return LogicalVolume(unique_id, children, size, params)
 
   @staticmethod
@@ -795,7 +455,7 @@ class LogicalVolume(BlockDev):
     if (not cls._VALID_NAME_RE.match(name) or
         name in cls._INVALID_NAMES or
         compat.any(substring in name for substring in cls._INVALID_SUBSTRINGS)):
-      _ThrowError("Invalid LVM name '%s'", name)
+      base.ThrowError("Invalid LVM name '%s'", name)
 
   def Remove(self):
     """Remove this logical volume.
@@ -807,7 +467,8 @@ class LogicalVolume(BlockDev):
     result = utils.RunCmd(["lvremove", "-f", "%s/%s" %
                            (self._vg_name, self._lv_name)])
     if result.failed:
-      _ThrowError("Can't lvremove: %s - %s", result.fail_reason, result.output)
+      base.ThrowError("Can't lvremove: %s - %s",
+                      result.fail_reason, result.output)
 
   def Rename(self, new_id):
     """Rename this logical volume.
@@ -822,7 +483,7 @@ class LogicalVolume(BlockDev):
                                    (self._vg_name, new_vg))
     result = utils.RunCmd(["lvrename", new_vg, self._lv_name, new_name])
     if result.failed:
-      _ThrowError("Failed to rename the logical volume: %s", result.output)
+      base.ThrowError("Failed to rename the logical volume: %s", result.output)
     self._lv_name = new_name
     self.dev_path = utils.PathJoin("/dev", self._vg_name, self._lv_name)
 
@@ -901,7 +562,7 @@ class LogicalVolume(BlockDev):
     """
     result = utils.RunCmd(["lvchange", "-ay", self.dev_path])
     if result.failed:
-      _ThrowError("Can't activate lv %s: %s", self.dev_path, result.output)
+      base.ThrowError("Can't activate lv %s: %s", self.dev_path, result.output)
 
   def Shutdown(self):
     """Shutdown the device.
@@ -973,15 +634,15 @@ class LogicalVolume(BlockDev):
 
     # remove existing snapshot if found
     snap = LogicalVolume((self._vg_name, snap_name), None, size, self.params)
-    _IgnoreError(snap.Remove)
+    base.IgnoreError(snap.Remove)
 
     vg_info = self.GetVGInfo([self._vg_name], False)
     if not vg_info:
-      _ThrowError("Can't compute VG info for vg %s", self._vg_name)
+      base.ThrowError("Can't compute VG info for vg %s", self._vg_name)
     free_size, _, _ = vg_info[0]
     if free_size < size:
-      _ThrowError("Not enough free space: required %s,"
-                  " available %s", size, free_size)
+      base.ThrowError("Not enough free space: required %s,"
+                      " available %s", size, free_size)
 
     _CheckResult(utils.RunCmd(["lvcreate", "-L%dm" % size, "-s",
                                "-n%s" % snap_name, self.dev_path]))
@@ -1006,7 +667,7 @@ class LogicalVolume(BlockDev):
     """Update metadata with info text.
 
     """
-    BlockDev.SetInfo(self, text)
+    base.BlockDev.SetInfo(self, text)
 
     self._RemoveOldInfo()
 
@@ -1027,7 +688,7 @@ class LogicalVolume(BlockDev):
       return
     if self.pe_size is None or self.stripe_count is None:
       if not self.Attach():
-        _ThrowError("Can't attach to LV during Grow()")
+        base.ThrowError("Can't attach to LV during Grow()")
     full_stripe_size = self.pe_size * self.stripe_count
     rest = amount % full_stripe_size
     if rest != 0:
